
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.GIRepository
    (     module GI.GIRepository.Callbacks        ,
    module GI.GIRepository.Enums            ,
    module GI.GIRepository.Flags            ,
    module GI.GIRepository.Functions        ,
    module GI.GIRepository.Objects          ,
    module GI.GIRepository.Structs          ,
    module GI.GIRepository.Unions           ,


    ) where

import GI.GIRepository.Callbacks
import GI.GIRepository.Enums
import GI.GIRepository.Flags
import GI.GIRepository.Functions
import GI.GIRepository.Objects
import GI.GIRepository.Structs
import GI.GIRepository.Unions

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.GIRepository.Types
import GI.GIRepository.Callbacks


